<html>
<head>
<title>OgrePlaneBoundedVolume.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePlaneBoundedVolume.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePlaneBoundedVolume_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __PlaneBoundedVolume_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __PlaneBoundedVolume_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSphere_8h.html">OgreSphere.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00048"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#ae42e7d91ba5c39178cfc681092e022a5">00051</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Plane&gt;::type</a> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html#ae42e7d91ba5c39178cfc681092e022a5">PlaneList</a>;
<a name="l00053"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a20b9a9b8d76a970c5f6cbac4cb438054">00053</a>         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html#ae42e7d91ba5c39178cfc681092e022a5">PlaneList</a> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a20b9a9b8d76a970c5f6cbac4cb438054" title="Publicly accessible plane list, you can modify this direct.">planes</a>;
<a name="l00054"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a4d323aac2569fdb268dd6dda2801896e">00054</a>         <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc" title="The &quot;positive side&quot; of the plane is the half space to which the plane normal points.">Plane::Side</a> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a4d323aac2569fdb268dd6dda2801896e">outside</a>;
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a9f3907950c9fd279e01ac1d4a03d9871">00056</a>         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a9f3907950c9fd279e01ac1d4a03d9871">PlaneBoundedVolume</a>() :outside(<a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>::NEGATIVE_SIDE) {}
<a name="l00058"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a1f07490e0ddb2809e1e2b71a89c23856">00058</a>         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>(<a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc" title="The &quot;positive side&quot; of the plane is the half space to which the plane normal points.">Plane::Side</a> theOutside) 
<a name="l00059"></a>00059             : outside(theOutside) {}
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#aee3ce7eff75f501f8d9a33faa9b64174">00064</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword">        </span>{
<a name="l00066"></a>00066             <span class="keywordflow">if</span> (box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#abeef4ea1111a90001287734529288749" title="Returns true if the box is null i.e.">isNull</a>()) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00067"></a>00067             <span class="keywordflow">if</span> (box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a45665abec389ae0ecbea54a26956a633" title="Returns true if the box is infinite.">isInfinite</a>()) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069             <span class="comment">// Get centre of the box</span>
<a name="l00070"></a>00070             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> centre = box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#a7407087b6542b79792d915c60c0b49f0" title="Gets the centre of the box.">getCenter</a>();
<a name="l00071"></a>00071             <span class="comment">// Get the half-size of the box</span>
<a name="l00072"></a>00072             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> halfSize = box.<a class="code" href="classOgre_1_1AxisAlignedBox.html#add9cf7a160ec472c91bf0fedb25cfed1" title="Gets the half-size of the box.">getHalfSize</a>();
<a name="l00073"></a>00073             
<a name="l00074"></a>00074             PlaneList::const_iterator i, iend;
<a name="l00075"></a>00075             iend = planes.end();
<a name="l00076"></a>00076             <span class="keywordflow">for</span> (i = planes.begin(); i != iend; ++i)
<a name="l00077"></a>00077             {
<a name="l00078"></a>00078                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane = *i;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080                 <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc" title="The &quot;positive side&quot; of the plane is the half space to which the plane normal points.">Plane::Side</a> side = plane.<a class="code" href="classOgre_1_1Plane.html#ae0131ee8cf1c09587c5cc4541c3b6297">getSide</a>(centre, halfSize);
<a name="l00081"></a>00081                 <span class="keywordflow">if</span> (side == outside)
<a name="l00082"></a>00082                 {
<a name="l00083"></a>00083                     <span class="comment">// Found a splitting plane therefore return not intersecting</span>
<a name="l00084"></a>00084                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00085"></a>00085                 }
<a name="l00086"></a>00086             }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088             <span class="comment">// couldn&#39;t find a splitting plane, assume intersecting</span>
<a name="l00089"></a>00089             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         }
<a name="l00095"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#a4b02564f2535f2bdf1ac38447582f61a">00095</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; sphere)<span class="keyword"> const</span>
<a name="l00096"></a>00096 <span class="keyword">        </span>{
<a name="l00097"></a>00097             PlaneList::const_iterator i, iend;
<a name="l00098"></a>00098             iend = planes.end();
<a name="l00099"></a>00099             <span class="keywordflow">for</span> (i = planes.begin(); i != iend; ++i)
<a name="l00100"></a>00100             {
<a name="l00101"></a>00101                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane = *i;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103                 <span class="comment">// Test which side of the plane the sphere is</span>
<a name="l00104"></a>00104                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d = plane.<a class="code" href="classOgre_1_1Plane.html#a9548b13f88e65d98ea08ba01c8f2fad1" title="This is a pseudodistance.">getDistance</a>(sphere.<a class="code" href="classOgre_1_1Sphere.html#ab33e56a0df43b2dfe3b72b59757e6f69" title="Returns the center point of the sphere.">getCenter</a>());
<a name="l00105"></a>00105                 <span class="comment">// Negate d if planes point inwards</span>
<a name="l00106"></a>00106                 <span class="keywordflow">if</span> (outside == <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e">Plane::NEGATIVE_SIDE</a>) d = -d;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108                 <span class="keywordflow">if</span> ( (d - sphere.<a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>()) &gt; 0)
<a name="l00109"></a>00109                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00110"></a>00110             }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="classOgre_1_1PlaneBoundedVolume.html#ae4528e95f68402ad6fea0ff6414dbeb7">00120</a>         <span class="keyword">inline</span> std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>&amp; ray)
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(ray, planes, outside == <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5">Plane::POSITIVE_SIDE</a>);
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     };
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">00127</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;PlaneBoundedVolume&gt;::type</a> <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a>;
<a name="l00128"></a>00128 
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
